﻿using System;
using System.Threading;
using System.Windows;
using System.Windows.Threading;

namespace PrintGridWithHeaderText_WPF
{
    /// <summary>
    /// Interaction logic for App.xaml
    /// </summary>
    public partial class App : Application
    {

        public static MainWindow MainWindow;
        public static Thread MainWindowThread;

        public static MainWindow2 MainWindow2;
        public static Thread MainWindow2Thread;

        public static Dispatcher AppDispatcher;

        private void Application_Startup(object sender, StartupEventArgs e)
        {

            {

                MainWindow2Thread = new Thread(new ThreadStart(() =>
                {

                    MainWindow2 = new MainWindow2();

                    MainWindow2.Closed += (s0, e0) =>
                    {

                        MainWindow2.Dispatcher.InvokeShutdown();
                        //App.CheckEnd();

                    };

                    MainWindow2.Show();

                    System.Windows.Threading.Dispatcher.Run();

                }));

                MainWindow2Thread.SetApartmentState(ApartmentState.STA);
                MainWindow2Thread.Start();

            }

            {

                MainWindowThread = new Thread(new ThreadStart(() =>
                {

                    MainWindow = new MainWindow();

                    MainWindow.Closed += (s0, e0) =>
                    {

                        MainWindow.Dispatcher.InvokeShutdown();
                        //App.CheckEnd();

                    };

                    MainWindow.Show();

                    System.Windows.Threading.Dispatcher.Run();

                }));

                MainWindowThread.SetApartmentState(ApartmentState.STA);
                MainWindowThread.Start();

            }

            AppDispatcher = this.Dispatcher;

            {

                Thread CheckRunning = new Thread(new ThreadStart(() =>
                {

                    while (true)
                    {

                        Thread.Sleep(500);

                        if (!MainWindowThread.IsAlive && !MainWindow2Thread.IsAlive) break;

                    }

                    App.InvokeOrSet(AppDispatcher, () =>
                    {

                        if (MainWindowThread.IsAlive) MainWindowThread.Abort();
                        if (MainWindow2Thread.IsAlive) MainWindow2Thread.Abort();

                        Application.Current.Shutdown();

                    });

                }));

                CheckRunning.IsBackground = true;
                CheckRunning.SetApartmentState(ApartmentState.STA);
                CheckRunning.Start();

            }

        }

        public static void InvokeOrSet(Dispatcher Dispatcher, Action Action)
        {

            if (Dispatcher != null)
            {

                if (Dispatcher.CheckAccess())
                {

                    Action();

                }
                else
                {

                    Dispatcher.BeginInvoke(DispatcherPriority.Background, new Action(() =>
                    {

                        Action();

                    }));

                }

            }

        }

    }
}
